Skip to content
Changelog

Report a bug

Zendesk integration: operations for AI agents

Zendesk connects to Type.com as an integration. This page lists the 672 operations documented for Claude and Codex in Type.com: 353 read, 122 write, 197 destructive.

About Zendesk

Zendesk Support API v2: 672 current authoritative endpoint references with explicit transport, authentication and account limits.

Categories: Sales & CRM

How to connect Zendesk to Type.com

Connect
Direct OAuth or composed email/token Basic credentials; managed Pipedream OAuth alternative.
Access
Organization connection: one shared account for the workspace.

To add the connection, follow the steps in Space connections.

Documented operations

672 operations. Your connection's permissions determine which operations are available. API references describe the vendor surface; they do not expand your connection's credentials or access.

672 operations listed.

Lookup Relationships

  • Read

    Get sources by target

    Returns a list of source objects whose values are populated with the id of a related target object. For example, if you have a lookup field called "Success Manager" on a ticket, this endpoint can answer the question, "What tickets (sources) is this user (found by `target_type` and `target_id`) assigned as the 'Success Manager' (field referenced by `field_id`)?" This endpoint also resolves [multi-lookup fields](/api-reference/ticketing/lookup_relationships/lookup_relationships/#about-multi-lookup-relationship-fields). Pass the multi-lookup field's id as `field_id` and "zen:ticket" as `source_type` to list the tickets that reference a target record through the field. Multi-lookup reverse lookups are resolved through search, so tickets the requesting agent can't view are excluded. #### Allowed For * Agents #### Pagination * Cursor pagination (recommended) * Offset pagination For a multi-lookup `field_id`, only cursor pagination applies. Offset pagination parameters are ignored and the response uses cursor pagination. See [Pagination](/api-reference/introduction/pagination/).

    GET /api/v2/{target_type}/{target_id}/relationship_fields/{field_id}/{source_type}

  • Read

    Filter Definitions

    Returns filter definitions based on the given target type. Target types include users (zen:user), tickets (zen:ticket), organizations (zen:organization), or custom objects (zen:custom_object:CUSTOM_OBJECT_KEY). The returned filter definitions are the options that you can use to build a custom field or ticket field's `relationship_filter`.

    GET /api/v2/relationships/definitions/{target_type}

Account Settings

  • Read

    Show Email Settings

    Returns the email settings for the account. #### Allowed For * Admins * Agents with extensions_and_channel_management permission

    GET /api/v2/account/email_settings

  • Read

    Show Settings

    Shows the settings that are available for the account. #### Allowed For * Agents

    GET /api/v2/account/settings

  • Destructive

    Update Email Settings

    Updates email settings for the account. #### Allowed For * Admins * Agents with extensions_and_channel_management permission

    PUT /api/v2/account/email_settings

  • Destructive

    Update Account Settings

    Updates settings for the account. See [JSON Format](#json-format) above for the settings you can update. #### Allowed For * Admins

    PUT /api/v2/account/settings

Reseller

  • Read

    Verify Subdomain Availability

    Zendesk Support credentials are not required to access this endpoint. You can use any Zendesk Support subdomain. Returns "true" if the subdomain is available.

    GET /api/v2/accounts/available

  • Write

    Create Trial Account

    Create Trial Account. See the pinned request/response schema and parameters for the authoritative contract.

    POST /api/v2/accounts

Activity Stream

  • Read

    List Activities

    Lists ticket activities in the last 30 days affecting the agent making the request. Also sideloads the following arrays of user records: - actors - All actors involved in the listed activities - users - All users involved in the listed activities #### Pagination - Cursor pagination (recommended) - Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Allowed For * Agents

    GET /api/v2/activities

  • Read

    Show Activity

    Lists a specific activity. #### Allowed For * Agents

    GET /api/v2/activities/{activity_id}

  • Read

    Count Activities

    Returns an approximate count of ticket activities in the last 30 days affecting the agent making the request. If the count exceeds 100,000, the count will return a cached result. This cached result will update every 24 hours. The `count[refreshed_at]` property is a timestamp that indicates when the count was last updated. **Note**: When the count exceeds 100,000, `count[refreshed_at]` may occasionally be null. This indicates that the count is being updated in the background, and `count[value]` is limited to 100,000 until the update is complete. #### Allowed For * Agents

    GET /api/v2/activities/count

Channel Framework

  • Read

    Validate Token

    #### Allowed For * Admins #### Request parameters The POST request takes a JSON object parameter which contains the token to be validated. | Name | Type | Required | Comments | ------------------ | ----------| --------- | ------------------- | instance_push_id | string | yes | The ID of the account to which data will be pushed. This was passed to the integration service when the administrator set up the account | request_id | string | no | A unique identifier for the push request #### Response format The response body is empty.

    POST /api/v2/any_channel/validate_token

  • Write

    Report Channelback Error to Zendesk

    #### Allowed For * Admins #### Request parameters The POST request takes a JSON object parameter which contains information about the problematic [channelback](/documentation/channel_framework/understanding-the-channel-framework/channelback/). | Name | Type | Required | Comments | ------------------ | ----------| --------- | ------------------- | instance_push_id | string | yes | The ID of the account to which data will be pushed. This was passed to the integration service when the administrator set up the account | external_id | string | yes | Unique identifier of the external resource from the original channelback (string) | description | string | no | A human readable description of the error | request_id | string | no | A unique identifier for the request #### Response format The response does not include a response body

    POST /api/v2/any_channel/channelback/report_error

  • Write

    Push Content to Support

    Pushes Channel framework content to Zendesk. #### Allowed For * Admins #### Request parameters The POST request takes a JSON object parameter which contains data about all the resources that the client is pushing. | Name | Type | Required | Comments | ------------------ | ----------| --------- | ------------------- | instance_push_id | string | yes | The account ID where data will be pushed. This was passed to the integration service when the administrator set up the account | request_id | string | no | A unique identifier for the push request | external_resources | array | yes | The [resources](#external_resource-object) to push #### external_resource object | Name | Type | Max length | Mandatory | Comments |------------------- | ---------------------------------- |------------| --------- | ---------- | external_id | string | 255 | yes | Unique identifier of the external resource. Must be ASCII characters | internal_note | boolean | | no | If true creates a new internal note comment | message | string | 65535 | yes | Text to be converted to a ticket or comment | html_message | string | 65535 | no | HTML version of message | parent_id | string | 511 | no | Unique identifier of the external resource for which this is a response. Used to choose the correct thread. Responses may include `parent_id` or `thread_id`, but not both. See [Conversation threads](/documentation/channel_framework/understanding-the-channel-framework/pull_endpoint/#conversation-threads) | thread_id | string | 255 | no | Arbitrary identifier of the thread to which this item should belong. Responses may include `parent_id` or `thread_id`, but not both. See [Conversation threads](/documentation/channel_framework/understanding-the-channel-framework/pull_endpoint/#conversation-threads) | created_at | string | | yes | When the resource was created in the origin system, as an ISO 8601 extended format date-time. Example: '2015-09-08T22:48:09Z' | author | object | | yes | See [author object](#author-object) below | display_info | array | | no | Array of integration-specific data used by apps to modify the agent UI. See [display_info object](#display_info-object) below | allow_channelback | boolean | | no | If false, prevents the agent from making additional comments on the message in the Zendesk interface | fields | array | | no | Array of ticket fields to set in Zendesk and their values. See [fields array](#fields-array) | file_urls | array | 10 | no | Array of files to be imported into Zendesk. See [file urls](/documentation/channel_framework/understanding-the-channel-framework/pull_endpoint/#file-urls) in the Channel framework docs #### author object | Name | Type | Max chars | Mandatory | Comments |------------ | ------ |---------- |---------- |----------- | external_id | string | 255 | yes | Unique identifier of the user in the origin service | name | string | 255 | no | If not supplied, defaults to external id | image_url | string | 255 | no | URL to an image for the user | locale | String | 255 | no | The user's locale. Must be one of the supported [locales](/api-reference/ticketing/account-configuration/locales/#list-available-public-locales) in Zendesk | fields | array | | no | Array of items containing user field identifier ('id') and value of field ('value'.) For system fields ('notes' or 'details'), the identifier is the English name. For custom fields, the identifier may be the ID or the name #### display_info object | Name | Type | Max chars | Mandatory | Comments |----- | ------ |---------- |---------- |----------- | type | string | 255 | yes | Globally unique type identifier defined by the integration origin service. Examples: a GUID or URI | data | string | 65535 | yes | JSON data containing display hints #### fields array The `fields` array lists ticket fields to set in Zendesk and their values. Each item consists of a field identifier (`id`) and a value (`value`) for the field. For Zendesk system fields such as `subject`, the identifier is the English name. For custom fields, the identifier may be a field ID or a name. See [Ticket Fields](/api-reference/ticketing/tickets/ticket_fields/). The `fields` array can only set ticket values on ticket creation, not on ticket updates. #### Response format The response is a JSON object containing a single key: | Name | Type | Comments | --------- | -------- | ------------------- | results | array | An array of [result objects](#result-object) The `results` array contains an entry for each item in the incoming `external_resources` array, in the same order. For example, if you call `push` with 3 external resources, a successful response will include `results` with three entries, corresponding to your 3 resources. #### result object | Name | Type | Comments | -------------------- | ------------------------------ | ------------------- | external_resource_id | string | The external ID of the resource, as passed in | status | object | The status of the import for the indicated resource. See [status object](#status-object) #### status object | Name | Type | Comments | ----------- | ------ | ------------------- | code | string | A code indicating the status of the import of the resource, as described in [status codes](#status-codes) | description | string | In the case of an exception, a description of the exception. Otherwise, not present. #### status codes | Key | Description | ----------------------------------------- | ---------------- | success | The external resource was successfully converted to a ticket or comment | already_imported | Reimport of the external resource was skipped due to a pre-existing ticket or comment for the resource | could_not_locate_parent_external_resource | The parent resource, as identified by parent_id in the [request](#request-parameters), could not be found. The unrecognized parent ID is returned in the description of the [status](#status-object) | processing_error | An internal exception occurred while processing the resource. See `description` in the [status object](#status-object) | halted | This resource was not processed because processing of previous resources failed

    POST /api/v2/any_channel/push

API Tokens

  • Read

    List API Tokens (deprecated)

    Lists the API tokens for the account. Token values are truncated in the response — see the `visible_token` property. **Deprecated.** API tokens are being removed as a supported authentication method for API requests. This endpoint is scheduled for removal on April 30, 2027. #### Allowed For * Admins * Agents with the [Manage APIs](https://support.zendesk.com/hc/en-us/articles/4408882153882) permission

    GET /api/v2/api_tokens

  • Write

    Create API Token (deprecated)

    Creates a new API token for the account. The response includes the full, unencrypted token value in the `token` property. This is the only time the full value is returned — store it securely, as it can't be retrieved again. On every subsequent request, the token is represented by its truncated `visible_token` value instead. **Deprecated.** API tokens are being removed as a supported authentication method for API requests. This endpoint is scheduled for removal on April 30, 2027. #### Allowed For * Admins * Agents with the [Manage APIs](https://support.zendesk.com/hc/en-us/articles/4408882153882) permission

    POST /api/v2/api_tokens

  • Destructive

    Update API Token (deprecated)

    Updates the description of an API token, or activates or deactivates it. Setting `active` to false deactivates the token, preventing it from being used to authenticate future API requests without deleting it. **Deprecated.** API tokens are being removed as a supported authentication method for API requests. This endpoint is scheduled for removal on April 30, 2027. #### Allowed For * Admins * Agents with the [Manage APIs](https://support.zendesk.com/hc/en-us/articles/4408882153882) permission

    PUT /api/v2/api_tokens/{id}

  • Destructive

    Delete API Token (deprecated)

    Permanently deletes an API token. An active token can't be deleted — it must be deactivated first by setting `active` to false on the Update API Token request. **Deprecated.** API tokens are being removed as a supported authentication method for API requests. This endpoint is scheduled for removal on April 30, 2027. #### Allowed For * Admins * Agents with the [Manage APIs](https://support.zendesk.com/hc/en-us/articles/4408882153882) permission

    DELETE /api/v2/api_tokens/{id}

Approval Requests

  • Read

    Show Approval Clarification Flow Messages

    Returns the clarification flow thread (comments exchanged between the requester and the approver) for an approval request. #### Allowed For * Agents * End users who can view the approval request's ticket, or who are its assignee

    GET /api/v2/approval_clarification_flow_messages/{approval_request_id}

  • Read

    List Approval Requests

    Lists all approval requests for the current account with optional filtering by status and assignee. #### Allowed For * Admins #### Query Parameters | Name | Type | Description |---------------------------|--------|-------------------------------------------------------------------------------------------- | filter[status] | string | Filter by a comma-separated list of one or more approval statuses. Values: active, approved, rejected, withdrawn | filter[assignee_user_id] | string | Filter by a comma-separated list of assigned user ids. Maximum 100 ids | filter[assignee_group_id] | string | Filter by a comma-separated list of assigned group ids. Maximum 100 ids | include | string | Comma-separated list of extra fields to sideload. Supports `deeplinks` — adds a `deeplink` field to each approval request, resolving to that request's agent-facing or Help Center decision page. Omitting `include` leaves the response unchanged. `include=deeplinks` requires the `approvals_api_parity` feature to be enabled for the account. When it isn't, `include=deeplinks` is silently ignored: no `deeplink` field is added, and the rest of the response is unaffected. #### Filtering Logic - When multiple values are provided for a filter, `or` logic is used. For example, `filter[status]=active,approved` is evaluated as `status=active OR status=approved`. - If multiple filters are applied to a single request, `AND` logic is used. For example, `filter[status]=active AND filter[assignee_user_id]=123`. - Each filter parameter supports a maximum 100 values. - Numeric ids must be valid integers. #### Pagination This endpoint supports cursor-based pagination. Use `after_cursor` and `before_cursor` parameters to navigate through results.

    GET /api/v2/approval_requests

  • Read

    Show Approval Request

    Shows a single approval request nested under its approval workflow instance. #### Allowed For * Agents assigned to the approval request

    GET /api/v2/approval_workflow_instances/{workflow_instance_id}/approval_requests/{id}

  • Write

    Create Approval Clarification Flow Message

    Adds a message to the clarification flow thread for an approval request and returns the full, updated thread. #### Allowed For * The approval request's assignee or creator, the ticket assignee, or a member of the assigned group * Any user who can view the ticket when the `approvals_allow_comments_from_ticket_viewers` feature is enabled

    POST /api/v2/approval_clarification_flow_messages

  • Write

    Create Approval Request

    Creates one or more approval requests for a ticket. When manual approval requests are turned off for the account, approval requests can still be created through this API. Approval requests created by the API have a `Sent by` value of `API`. #### Allowed For * System users (flowstate) * Agents #### Single approval request To create a single approval request, supply a top-level `assignee_user_id` or `assignee_group_id`. This is helpful when only one approval is required or approvals need to be received in a specific order. The response returns the created request under the `approval_request` key. See the **Example body** and **Example response(s)** sections below for the single-request request and response shapes. #### Parallel approval requests To create multiple approval requests at once, for the approvers to review and respond to in parallel, supply an `approval_requests` array. The approval request's `subject` and `message` are set once at the top level and apply to every individual approval request in the array. The approval requests are created atomically as an array under the `approval_requests` key, and all share the same `approval_workflow_instance_id`. If any of the approval request entries are invalid, none of the requests are created. To avoid invalid entries, do the following: * Specify exactly one `assignee_user_id` or `assignee_group_id` for each entry in the `approval_requests` array. * Make sure you don't combine a top-level `assignee_user_id` or `assignee_group_id` with the `approval_requests` array. Doing so returns a `422`. Example request: ```bash curl https://{subdomain}.zendesk.com/api/v2/approval_requests \ -H "Content-Type: application/json" -X POST \ -d '{"ticket_id": 123, "subject": "Budget Approval", "message": "Please approve the Q1 budget", "approval_requests": [{"assignee_user_id": 101}, {"assignee_group_id": 202}]}' \ -v -u {email_address}/token:{api_token} ``` Example response: ```json { "approval_requests": [ { "id": "01KFP3S9EVXF9CKAYY080NV98C", "approval_workflow_instance_id": "01KFP3S9EVXF9CKAYY080NV98D", "subject": "Budget Approval", "message": "Please approve the Q1 budget", "status": "active", "created_at": "2026-01-23T19:02:36Z", "created_by_id": 789, "assignee_user_id": 101, "assignee_group_id": null, "ticket_id": 123, "origination_type": "API_ORIGINATION" }, { "id": "01KFP3S9EVXF9CKAYY080NV98E", "approval_workflow_instance_id": "01KFP3S9EVXF9CKAYY080NV98D", "subject": "Budget Approval", "message": "Please approve the Q1 budget", "status": "active", "created_at": "2026-01-23T19:02:36Z", "created_by_id": 789, "assignee_user_id": null, "assignee_group_id": 202, "ticket_id": 123, "origination_type": "API_ORIGINATION" } ] } ```

    POST /api/v2/approval_requests

  • Write

    Decide Approval Request

    Records a decision (approve, reject, or withdraw) on an approval request, with optional notes. #### Allowed For * The user or a member of the group assigned to review the approval request The ticket requester, the ticket assignee, and the user who created the approval request are not allowed to decide on it, even when they are also the assignee.

    PATCH /api/v2/approval_workflow_instances/{workflow_instance_id}/approval_requests/{id}/decision

  • Write

    Withdraw Approval Workflow Instance

    Withdraws every non-withdrawn approval request in the given workflow instance and marks the workflow instance as withdrawn. Works for both parallel and non-parallel workflow instances. #### Allowed For * Agents who can manage approval requests and edit the associated ticket, and who are either the approval request's requester or the ticket's assignee

    PATCH /api/v2/approval_workflow_instances/{workflow_instance_id}/withdraw

Attachments

  • Read

    Show Attachment

    Shows attachment details. You can get the value of the `attachment_id` parameter by listing the ticket's comments. See [List Comments](/api-reference/ticketing/tickets/ticket_comments/#list-comments). Each comment in the list has an `attachments` list that specifies an `id` for each attachment. #### Allowed for * Agents

    GET /api/v2/attachments/{attachment_id}

  • Write

    Upload Files

    Uploads a file that can be attached to a ticket comment. It doesn't attach the file to the comment. For details and examples, see [Attaching ticket comments with the API](/documentation/ticketing/managing-tickets/adding-ticket-attachments-with-the-api/). The endpoint has a required `filename` query parameter. The parameter specifies what the file will be named when attached to the ticket comment (to give the agent more context about the file). The parameter does not specify the file on the local system to be uploaded. While the two names can be different, their file extensions must be the same. If they don't match, the agent's browser or file reader could give an error when attempting to open the attachment. The `Content-Type` header must contain a recognized MIME type that correctly describes the type of the uploaded file. Failing to send a recognized, correct type may cause undesired behavior. For example, in-browser audio playback may be interrupted by the browser's security mechanisms for MP3s uploaded with an incorrect type. Adding multiple files to the same upload is handled by splitting requests and passing the API token received from the first request to each subsequent request. The token is valid for 60 minutes. **Note**: Even if [private attachments](https://support.zendesk.com/hc/en-us/articles/8435939957914) are enabled in the Zendesk Support instance, uploaded files are visible to any authenticated user at the `content_URL` specified in the [JSON response](#json-format) until the upload token is consumed. Once a file is associated with a ticket or post, visibility is restricted to users with access to the ticket or post with the attachment. #### Allowed For * End users

    POST /api/v2/uploads

  • Destructive

    Update Attachment for Malware

    Toggles enabling or restricting agent access to attachments with detected malware. #### Allowed For * Admins

    PUT /api/v2/attachments/{attachment_id}

  • Destructive

    Delete Attachment

    Deletes the attachment. #### Allowed for * Agents

    DELETE /api/v2/attachments/{attachment_id}

  • Destructive

    Redact Comment Attachment

    Redaction allows you to permanently remove attachments from an existing comment on a ticket. Once removed from a comment, the attachment is replaced with an empty "redacted.txt" file. The redaction is permanent. It is not possible to undo redaction or see what was removed. Once a ticket is closed, redacting its attachments is no longer possible. Also, if you want to redact an inline attachment, you can use the `include_inline_images` parameter in the [List Comments](/api-reference/ticketing/tickets/ticket_comments/#list-comments) operation to obtain the inline attachment ID, and use it in the request URL. #### Allowed For * Admins * Agents when [deleting tickets is enabled for agents on professional accounts](https://support.zendesk.com/hc/en-us/articles/4408832689818) * Agents assigned to a custom role with permissions to redact ticket content (Enterprise only)

    PUT /api/v2/tickets/{ticket_id}/comments/{comment_id}/attachments/{attachment_id}/redact

  • Destructive

    Delete Upload

    #### Allowed for * End Users

    DELETE /api/v2/uploads/{token}

Audit Logs

  • Read

    List Audit Logs

    #### Allowed For * Admins on accounts that have audit log access #### Pagination * Cursor pagination (recommended) * Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Filtering by multiple values To filter by multiple values for the same field, repeat the filter parameter and append empty square brackets "[]" to the name of each repeated parameter. For example, to return audit logs where `action` is "create", "update", or "destroy": `/api/v2/audit_logs?filter[action][]=create&filter[action][]=update&filter[action][]=destroy`

    GET /api/v2/audit_logs

  • Read

    Show Audit Log

    #### Allowed For * Admins on accounts that have audit-log access

    GET /api/v2/audit_logs/{audit_log_id}

  • Write

    Export Audit Logs

    #### Allowed For * Admins on accounts that have audit log access #### Limits This endpoint's rate limit is different from the account-wide rate limit. The rate limit is one request per minute per account. When this limit is reached, you'll get a `429 Too Many Requests` response code. ##### Headers API responses include usage limit information in the headers for this endpoint. ``` Zendesk-RateLimit-audit-logs-export: total={number}; remaining={number}; resets={number} ``` Within this header, “Total” signifies the initial allocation, “Remaining” indicates the remaining allowance for the current interval, and “Resets” denotes the wait time in seconds before the limit refreshes. You can see the Total, and Interval values in the below table. ##### Details The rate limit is one request per minute per account. If you exceed this, you'll receive the following error: "Rate limit for Audit log CSV Export exceeded. Please wait 1 minute and try again."

    POST /api/v2/audit_logs/export

Tags

  • Read

    Search Tags

    Returns an array of registered and recent tag names that start with the characters specified in the `name` query parameter. This includes tags where any word within the tag (separated by underscores, hyphens, spaces, or other punctuation) starts with the specified characters. You must specify at least 2 characters. #### How tag matching works When tags contain delimiters like underscores, hyphens, or spaces, each word is indexed separately. A tag matches if the tag itself or any word within it starts with your search term. For example, searching for `trig` will match the tag `set_by_this_trigger` because one of its words ("trigger") starts with "trig". However, searching for `rigger` won't match this tag because neither the full tag nor any of its individual words ("set", "by", "this", "trigger") start with "rigger". #### Autocomplete limitations Autocomplete returns up to 15 suggestions from the most commonly used ticket tags in the last 60 days. Tags that match the prefix but aren't in that top set won't appear in the results. #### Pagination * Offset pagination only See [Using Offset Pagination](/api-reference/introduction/pagination/#using-offset-pagination). #### Allowed For * Agents

    GET /api/v2/autocomplete/tags

  • Read

    Search Tags by Request Body

    Returns an array of registered and recent tag names that start with the characters specified in the `name` parameter. This includes tags where any word within the tag (separated by underscores, hyphens, spaces, or other punctuation) starts with the specified characters. You must specify at least 2 characters. This endpoint accepts the same parameters as the [GET method](#search-tags) but they are specified in the request body instead of the query string. #### How tag matching works When tags contain delimiters like underscores, hyphens, or spaces, each word is indexed separately. A tag matches if the tag itself or any word within it starts with your search term. For example, searching for `trig` will match the tag `set_by_this_trigger` because one of its words ("trigger") starts with "trig". However, searching for `rigger` won't match this tag because neither the full tag nor any of its individual words ("set", "by", "this", "trigger") start with "rigger". #### Autocomplete limitations Autocomplete returns up to 15 suggestions from the most commonly used ticket tags in the last 60 days. Tags that match the prefix but aren't in that top set won't appear in the results. #### Allowed For * Agents

    POST /api/v2/autocomplete/tags

  • Read

    List Organization Tags

    #### Allowed For * Agents

    GET /api/v2/organizations/{organization_id}/tags

  • Read

    List Tags

    Lists up to the 20,000 most popular tags in the last 60 days, in decreasing popularity. #### Pagination * Cursor pagination (recommended) * Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Allowed For * Agents

    GET /api/v2/tags

  • Read

    Count Tags

    Returns an approximate count of tags. If the count exceeds 100,000, it is updated every 24 hours. The `refreshed_at` property of the `count` object is a timestamp that indicates when the count was last updated. **Note**: When the count exceeds 100,000, the `refreshed_at` property in the `count` object may occasionally be null. This indicates that the count is being updated in the background and the `value` property in the `count` object is limited to 100,000 until the update is complete. #### Allowed For * Agents

    GET /api/v2/tags/count

  • Read

    List Resource Tags

    #### Allowed For * Agents

    GET /api/v2/tickets/{ticket_id}/tags

  • Read

    List User Tags

    #### Allowed For * Agents

    GET /api/v2/users/{user_id}/tags

  • Write

    Set Organization Tags

    #### Allowed For * Agents

    POST /api/v2/organizations/{organization_id}/tags

  • Write

    Set Tags

    #### Allowed For * Agents

    POST /api/v2/tickets/{ticket_id}/tags

  • Write

    Set User Tags

    #### Allowed For * Agents

    POST /api/v2/users/{user_id}/tags

  • Destructive

    Add Organization Tags

    #### Allowed For * Agents

    PUT /api/v2/organizations/{organization_id}/tags

  • Destructive

    Remove Organization Tags

    #### Allowed For * Agents

    DELETE /api/v2/organizations/{organization_id}/tags

  • Destructive

    Add Tags

    You can also add tags to multiple tickets with the [Update Many Tickets](/api-reference/ticketing/tickets/tickets/#update-many-tickets) endpoint. #### Safe Update If the same ticket is updated by multiple API requests at the same time, some tags could be lost because of ticket update collisions. Include `updated_stamp` and `safe_update` properties in the request body to make a safe update. For `updated_stamp`, retrieve and specify the ticket's latest `updated_at` timestamp. The tag update only occurs if the `updated_stamp` timestamp matches the ticket's actual `updated_at` timestamp at the time of the request. If the timestamps don't match (in other words, if the ticket was updated since you retrieved the ticket's last `updated_at` timestamp), the request returns a 409 Conflict error. #### Example ```js { "tags": ["customer"], "updated_stamp":"2019-09-12T21:45:16Z", "safe_update":"true" } ``` For details, see [Protecting against ticket update collisions](/api-reference/ticketing/tickets/tickets/#protecting-against-ticket-update-collisions). #### Allowed For * Agents

    PUT /api/v2/tickets/{ticket_id}/tags

  • Destructive

    Remove Tags

    You can also delete tags from multiple tickets with the [Update Many Tickets](/api-reference/ticketing/tickets/tickets/#update-many-tickets) endpoint. This endpoint supports safe updates. See [Safe Update](/api-reference/ticketing/ticket-management/tags/#safe-update). #### Allowed For * Agents

    DELETE /api/v2/tickets/{ticket_id}/tags

  • Destructive

    Add User Tags

    #### Allowed For * Agents

    PUT /api/v2/users/{user_id}/tags

  • Destructive

    Remove User Tags

    #### Allowed For * Agents

    DELETE /api/v2/users/{user_id}/tags

Automations

  • Read

    List Automations

    Lists all automations for the current account. #### Allowed For * Agents #### Available Parameters You can pass in any combination of the following optional filters: | Name | Type | Comment | ---------- | ------- | ------- | active | boolean | Only active automations if true, inactive automations if false | sort_by | string | Possible values are "alphabetical", "created_at", "updated_at", "usage_1h", "usage_24h", or "usage_7d". Defaults to "position" | sort_order | string | One of "asc" or "desc". Defaults to "asc" for alphabetical and position sort, "desc" for all others #### Sideloads The following sideloads are supported. The usage sideloads are only supported on the Support Professional or Suite Growth plan or above. | Name | Will sideload | ---------------- | ------------- | app_installation | The app installation that requires each automation, if present | permissions | The permissions for each automation | usage_1h | The number of tickets processed by an automation in the past hour | usage_24h | The number of tickets processed by an automation in the past day | usage_7d | The number of tickets processed by an automation in the past week | usage_30d | The number of tickets processed by an automation in the past thirty days #### Pagination - Cursor pagination (recommended) - Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page.

    GET /api/v2/automations

  • Read

    Show Automation

    #### Allowed For * Agents

    GET /api/v2/automations/{automation_id}

  • Read

    List Active Automations

    Lists all active automations. #### Allowed For * Agents #### Available Parameters You can pass in any combination of the following optional filters: | Name | Type | Comment | ---------- | ------ | ------- | sort_by | string | Possible values are "alphabetical", "created_at", "updated_at", "usage_1h", "usage_24h", or "usage_7d". Defaults to "position" | sort_order | string | One of "asc" or "desc". Defaults to "asc" for alphabetical and position sort, "desc" for all others #### Sideloads The following sideloads are supported: | Name | Will sideload | ---------------- | ------------- | app_installation | The app installation that requires each automation, if present | permissions | The permissions for each automation | usage_1h | The number of tickets processed by an automation in the past hour | usage_24h | The number of tickets processed by an automation in the past day | usage_7d | The number of tickets processed by an automation in the past week | usage_30d | The number of tickets processed by an automation in the past thirty days

    GET /api/v2/automations/active

  • Read

    Search Automations

    #### Pagination * Offset pagination only See [Using Offset Pagination](/api-reference/introduction/pagination/#using-offset-pagination). #### Allowed For * Agents #### Sideloads The following sideloads are supported. For more information, see [Side-loading](/documentation/ticketing/using-the-zendesk-api/side_loading/). | Name | Will sideload | ---------------- | ------------- | app_installation | The app installation that requires each automation, if present | permissions | The permissions for each automation | usage_1h | The number of tickets processed by an automation in the past hour | usage_24h | The number of tickets processed by an automation in the past day | usage_7d | The number of tickets processed by an automation in the past week | usage_30d | The number of tickets processed by an automation in the past thirty days

    GET /api/v2/automations/search

  • Write

    Create Automation

    Creates an automation. New automations must be unique and have at least one condition that is true only once or an action that nullifies at least one of the conditions. Active automations can have overlapping conditions but can't be identical. The request must include the following conditions in the `all` array: - At least one time-based condition - At least one condition that checks one of the following fields: `status`, `type`, `group_id`, `assignee_id`, or `requester_id`. #### Allowed For * Agents

    POST /api/v2/automations

  • Destructive

    Update Automation

    Updates an automation. Updated automations must be unique and have at least one condition that is true only once or an action that nullifies at least one of the conditions. Active automations can have overlapping conditions but can't be identical. The request must include the following conditions in the `all` array: - At least one time-based condition - At least one condition that checks one of the following fields: 'status', 'type', 'group_id', 'assignee_id', or 'requester_id' **Note**: Updating a condition or action updates both the `conditions` and `actions` arrays, clearing all existing values of both arrays. Include all your conditions and actions when updating any condition or action. **Note**: You might be restricted from updating some default automations. #### Allowed For * Agents

    PUT /api/v2/automations/{automation_id}

  • Destructive

    Delete Automation

    **Note**: You might be restricted from deleting some default automations. #### Allowed For * Agents

    DELETE /api/v2/automations/{automation_id}

  • Destructive

    Bulk Delete Automations

    Deletes the automations corresponding to the provided comma-separated list of IDs. **Note**: You might be restricted from deleting some default automations. If included in a bulk deletion, the unrestricted automations will be deleted. #### Allowed For * Agents #### Request Parameters The DELETE request takes one parameter, an `ids` object that lists the automations to delete. | Name | Description | ---- | ----------- | ids | The IDs of the automations to delete #### Example request ```js { "ids": "25,23,27,22" } ```

    DELETE /api/v2/automations/destroy_many

  • Destructive

    Update Many Automations

    **Note**: You might be restricted from updating some default automations. If included in a bulk update, the unrestricted automations will be updated. #### Allowed For * Agents #### Request Parameters The PUT request expects an `automations` object that lists the automations to update. Each automation may have the following properties: | Name | Mandatory | Description | -------- | --------- | ----------- | id | yes | The ID of the automation to update | position | no | The new position of the automation | active | no | The active status of the automation (true or false) #### Example Request ```js { "automations": [ {"id": 25, "position": 3}, {"id": 23, "position": 5}, {"id": 27, "position": 9}, {"id": 22, "position": 7} ] } ```

    PUT /api/v2/automations/update_many

Bookmarks

  • Read

    List Bookmarks

    Archived tickets are not included in the response. See [About archived tickets](https://support.zendesk.com/hc/en-us/articles/4408887617050) in Zendesk help. #### Allowed For - Agents

    GET /api/v2/bookmarks

  • Write

    Create Bookmark

    #### Allowed For - Agents

    POST /api/v2/bookmarks

  • Destructive

    Delete Bookmark

    #### Allowed For - Agents (own bookmarks only) If the bookmark already exists with a specified ticket id, the response status will be `http Status: 200 OK`.

    DELETE /api/v2/bookmarks/{bookmark_id}

Brand Agents

  • Read

    List Brand Agent Memberships

    Returns a list of all brand agent memberships for your account. #### Pagination * Cursor pagination (recommended) * Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Allowed For: * Admins

    GET /api/v2/brand_agents

  • Read

    Show Brand Agent Membership

    Returns a brand agent membership for your account. #### Allowed For * Admins

    GET /api/v2/brand_agents/{brand_agent_id}

  • Read

    List Agents By Brand

    Returns a list of all agents assigned to a specific brand. #### Pagination * Cursor pagination (recommended) * Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Allowed For: * Admins

    GET /api/v2/brands/{brand_id}/agents

  • Read

    List Brand Agent Memberships By User

    Returns a list of all brand agent memberships for a specific user. #### Pagination * Cursor pagination (recommended) * Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Allowed For: * Admins

    GET /api/v2/users/{user_id}/brand_agents

  • Read

    Show Brand Agent Membership By User

    Returns a specific brand agent membership for a user. #### Allowed For * Admins

    GET /api/v2/users/{user_id}/brand_agents/{brand_agent_id}

  • Write

    Create Brand Agent Membership

    Creates a brand agent membership, granting the agent access to the brand. Returns `422` if the user is not an agent, the brand does not belong to the account, or a membership for the same user and brand already exists. #### Allowed For: * Admins

    POST /api/v2/brand_agents

  • Destructive

    Delete Brand Agent Membership

    Deletes a brand agent membership, removing the agent's access to the brand. The `brand_agent_id` is the id of the brand agent membership returned by the list and show endpoints, not the id of the brand or the user. #### Allowed For * Admins

    DELETE /api/v2/brand_agents/{brand_agent_id}

Brands

  • Read

    List Brands

    Returns a list of all brands for your account sorted by name. #### Allowed for * Admins * Agents with the `assign_tickets_to_any_brand` permission can list all brands for the account * Agents without the `assign_tickets_to_any_brand` permission can only list brands they are members of #### Pagination * Cursor pagination See [Pagination](/api-reference/introduction/pagination/).

    GET /api/v2/brands

  • Read

    Show a Brand

    Returns a brand for your account. #### Allowed for * Admins, Agents

    GET /api/v2/brands/{brand_id}

  • Read

    Check Host Mapping Validity for an Existing Brand

    Returns a JSON object determining whether a host mapping is valid for the given brand. #### Allowed for - Admins

    GET /api/v2/brands/{brand_id}/check_host_mapping

  • Read

    Check Host Mapping Validity

    Returns a JSON object determining whether a host mapping is valid for a given subdomain. #### Allowed for * Admins

    GET /api/v2/brands/check_host_mapping

  • Write

    Create Brand

    Creates a brand. To attach a logo, make a follow-up request to `PUT /api/v2/brands/{brand_id}/logo`. #### Allowed for - Admins

    POST /api/v2/brands

  • Destructive

    Update a Brand

    Returns an updated brand. #### Allowed for * Admins #### Updating a Brand's Image Use `PUT /api/v2/brands/{brand_id}/logo` to set or replace the brand logo, and `DELETE /api/v2/brands/{brand_id}/logo` to remove it.

    PUT /api/v2/brands/{brand_id}

  • Destructive

    Delete a Brand

    Deletes a brand. #### Allowed for - Admins

    DELETE /api/v2/brands/{brand_id}

X Channel

  • Read

    List Monitored X Handles

    #### Allowed For * Admins * Agents

    GET /api/v2/channels/twitter/monitored_twitter_handles

  • Read

    Show Monitored X Handle

    #### Allowed For * Admins * Agents

    GET /api/v2/channels/twitter/monitored_twitter_handles/{monitored_twitter_handle_id}

  • Read

    List Ticket statuses

    #### Allowed For * Agents

    GET /api/v2/channels/twitter/tickets/{comment_id}/statuses

  • Write

    Create Ticket from Tweet

    Turns a tweet into a ticket. You must provide the tweet id as well as the id of a monitored X (formerly Twitter) handle configured for your account. The submitter of the ticket is set to be the user submitting the API request. #### Allowed For * Agents

    POST /api/v2/channels/twitter/tickets

Basics

  • Write

    Open Ticket in Agent's Browser

    Allows you to instruct an agent's browser to open a ticket. When the message is successfully delivered to an agent's browser: ```http Status: 200 OK ``` When `agent_id` or `ticket_id` is invalid: ```http Status: 404 Not Found ``` #### Allowed For * Agents

    POST /api/v2/channels/voice/agents/{agent_id}/tickets/{ticket_id}/display

  • Write

    Open a User's Profile in an Agent's Browser

    Allows you to instruct an agent's browser to open a user's profile. When the message is successfully delivered to an agent's browser: ```http Status: 200 OK ``` When `agent_id` or `user_id` is invalid: ```http Status: 404 Not Found ``` #### Allowed For * Agents

    POST /api/v2/channels/voice/agents/{agent_id}/users/{user_id}/display

  • Write

    Create Ticket or Voicemail Ticket

    #### Allowed For * Agents ### Creating tickets #### Introduction Creating tickets using Talk Partner Edition follows the same conventions as the Create Ticket endpoint. See [Create Ticket](/api-reference/ticketing/tickets/tickets/#create-ticket). #### Request parameters The POST request takes a mandatory `ticket` object that lists the values to set when the ticket is created. You may also include an optional `display_to_agent` value such as the ID of the agent that will see the newly created ticket. The `display_to_agent` is validated before creating the ticket, returning a 422 error if it is invalid. Tickets created using this endpoint must have a `via_id` parameter. See the following section for possible values. #### Zendesk Talk Integration Via IDs Tickets created using this endpoint must have one of the following `via_id` parameters: | ID | Description | ---------| ------------- | 44 | Voicemail | 45 | Phone call (inbound) | 46 | Phone call (outbound) ### Creating voicemail tickets #### Request parameters The POST request takes a mandatory `ticket` object that lists the values to set when the ticket is created. The ticket must have a `voice_comment` with the following values: | Name | Type | Comment | ------------------ | ----------------------| ------- | from | string | Incoming phone number | to | string | Dialed phone number | recording_url | string | URL of the recording | recording_type | string | Type of recording (call, voicemail, or ai) | started_at | date | [ISO 8601](http://en.wikipedia.org/wiki/ISO_8601) timestamp of the call starting time | call_duration | integer | Duration in seconds of the call | answered_by_id | integer | The agent who answered the call | transcription_text | string | Transcription of the call (optional) | location | string | Location of the caller (optional)

    POST /api/v2/channels/voice/tickets

WhatsApp Templates

  • Read

    List WhatsApp Templates

    Returns the WhatsApp message templates synced from SunCo for the account's WhatsApp integrations. Only templates approved by WhatsApp are synced. Listing triggers a freshness check per integration. If local data is missing or stale, a background sync is started and the `syncing` flag is set in the response. The list may be incomplete while that flag is set, so poll until it clears. #### Pagination * Cursor pagination (recommended) * Offset pagination See [Pagination](/api-reference/introduction/pagination/). #### Allowed For * Agents

    GET /api/v2/channels/whatsapp_templates

  • Read

    List WhatsApp Template Languages

    Returns the distinct languages present across the account's synced WhatsApp message templates. Use it to populate a language filter for [List WhatsApp Templates](#list-whatsapp-templates). #### Allowed For * Agents

    GET /api/v2/channels/whatsapp_templates/languages

  • Destructive

    Toggle WhatsApp Template

    Enables or disables a single WhatsApp message template for the account. Activation is controlled by admins and is never overwritten by a sync from SunCo. #### Allowed For * Admins

    PUT /api/v2/channels/whatsapp_templates/{template_id}/toggle

  • Destructive

    Bulk Toggle WhatsApp Templates

    Enables or disables several WhatsApp message templates in one request. All templates are set to the same `is_active` value. The update is applied only if every supplied `template_id` exists on the account. #### Allowed For * Admins

    PUT /api/v2/channels/whatsapp_templates/toggle_many

Ticket Comments

  • Read

    List Comments

    Returns the comments added to the ticket. Each comment may include a `content_url` for an attachment or a `recording_url` for a voice comment that points to a file that may be hosted externally. For security reasons, take care not to inadvertently send Zendesk authentication credentials to third parties when attempting to access these files. See [Working with url properties](/documentation/api-basics/best-practices/working-with-url-properties/). #### Pagination - Cursor pagination (recommended) - Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Sorting By default, comments are sorted by creation date in ascending order. When using cursor pagination, use the following parameter to change the sort order: | Name | Type | Required | Comments | ------ | ------ | -------- | -------- | `sort` | string | no | Possible values are "created_at" (ascending order) or "-created_at" (descending order) When using offset pagination, use the following parameters to change the sort order: | Name | Type | Required | Comments | ------------ | ------ | -------- | -------- | `sort_order` | string | no | One of `asc`, `desc`. Defaults to `asc` #### Allowed For * Agents

    GET /api/v2/tickets/{ticket_id}/comments

  • Read

    Count Ticket Comments

    Returns an approximate count of the comments added to the ticket. If the count exceeds 100,000, the count will return a cached result. This cached result will update every 24 hours. The `count[refreshed_at]` property is a timestamp that indicates when the count was last updated. **Note**: When the count exceeds 100,000, `count[refreshed_at]` may occasionally be null. This indicates that the count is being updated in the background, and `count[value]` is limited to 100,000 until the update is complete. #### Allowed For * Agents

    GET /api/v2/tickets/{ticket_id}/comments/count

  • Destructive

    Redact Chat Comment Attachment

    Permanently removes one or more chat attachments from a chat ticket. **Note**: This does not work on active chats. For chat tickets that predate March 2020, consider using [Redact Ticket Comment In Agent Workspace](#redact-ticket-comment-in-agent-workspace). #### Allowed For - Agents [Agent Workspace](https://support.zendesk.com/hc/en-us/articles/4408821259930) must enabled for the account. Deleting tickets must be enabled for agents. #### Request Body Properties | Name | Type | Required | Description | | ------------ | ------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | | chat_id | string | true | The `chat_id` in the `ChatStartedEvent` event in the ticket audit. See [Ticket Audits](/api-reference/ticketing/tickets/ticket_audits) | | chat_indexes | array | false | The array of `chat_index` in the `ChatFileAttachment` event in the ticket audit. See [Ticket Audits](/api-reference/ticketing/tickets/ticket_audits). Mandatory if `message_ids` is not used | | message_ids | array | false | The array of `message_id` in the `ChatFileAttachment` event in the ticket audit that is part of a `ChatStartedEvent` history. Used when redacting a ChatFileAttachment that is part of a conversation history. Mandatory if `chat_indexes` is not used | To get the required body properties, make a request to the [Ticket Audits](/api-reference/ticketing/tickets/ticket_audits) endpoint. Example response: ```http Status 200 OK { "audits": [ "events": [ { "id": 1932802680168, "type": "ChatStartedEvent", "value": { "visitor_id": "10502823-16EkM3T6VNq7KMd", "chat_id": "2109.10502823.Sjuj2YrBpXwei", "history": [ { "chat_index": 0, "type": "ChatFileAttachment", "filename": "image1.jpg" }, { "chat_index": 1, "type": "ChatFileAttachment", "filename": "image2.jpg" } ] } } ] ] } ```

    PUT /api/v2/chat_file_redactions/{ticket_id}

  • Destructive

    Redact Chat Comment

    Permanently removes words or strings from a chat ticket's comment. Wrap `<redact>` tags around the content in the chat comment you want redacted. Example: ```json { "text": "My ID number is <redact>847564</redact>!" } ``` The characters contained in the tag will be replaced by the ▇ symbol. **Note**: This does not work on active chats. For chat tickets that predate March 2020, consider using [Redact Ticket Comment In Agent Workspace](#redact-ticket-comment-in-agent-workspace). **Limitations**: - Redaction is a synchronous process. For archived tickets, only one redaction request can be processed at a time per ticket. Concurrent redaction requests on the same archived ticket will receive a 409 Conflict response with a `Retry-After` header indicating how many seconds to wait before retrying (up to 30 seconds). The lock is released immediately when the redaction completes. This limit does not apply to requests from the Zendesk UI. #### Allowed For - Agents [Agent Workspace](https://support.zendesk.com/hc/en-us/articles/4408821259930) must enabled for the account. Deleting tickets must be enabled for agents. #### Request Body Properties | Name | Type | Required | Description | | ------------------------ | ------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | | chat_id | string | true | The `chat_id` in the `ChatStartedEvent` event in the ticket audit. See [Ticket Audits](/api-reference/ticketing/tickets/ticket_audits) | | chat_index | integer | false | The `chat_index` in the `ChatMessage` event in the ticket audit. See [Ticket Audits](/api-reference/ticketing/tickets/ticket_audits). Mandatory if `message_id` is not used | | message_id | string | false | The `message_id` of the `ChatMessage` event in the ticket audit that is part of a `ChatStartedEvent` history. Used when redacting a ChatMessage that is part of a conversation history. Mandatory if `chat_index` is not used | | text | string | true | The `message` in the `ChatMessage` event in the ticket audit. See [Ticket Audits](/api-reference/ticketing/tickets/ticket_audits). Wrap `message` with `<redact>` tags | To get the required body properties, make a request to the [Ticket Audit](/api-reference/ticketing/tickets/ticket_audits) endpoint. Example response: ```http Status 200 OK { "audits": [ "events": [ { "id": 1932802680168, "type": "ChatStartedEvent", "value": { "visitor_id": "10502823-16EkM3T6VNq7KMd", "chat_id": "2109.10502823.Sjuj2YrBpXwei", "history": [ { "chat_index": 0, "type": "ChatMessage", "message": "My ID number is 847564!" } ] } } ] ] } ```

    PUT /api/v2/chat_redactions/{ticket_id}

  • Destructive

    Redact Ticket Comment In Agent Workspace

    Redaction allows you to permanently remove words, strings, or attachments from a ticket comment. In the `html_body` of the comment, wrap the content you want redacted in `<redact>` tags. Example: ```json { "html_body": "<div class=\"zd-comment\" dir=\"auto\">My ID number is <redact>847564</redact>!</div>", "ticket_id":100 } ``` The characters in the redact tag will be replaced by the ▇ symbol. To redact HTML elements such inline images, anchor tags, and links, add the `redact` tag attribute to the element as well as the `<redact>` tag to inner text, if any. Example: `<a href="http://example.com" redact><redact>some link</redact></a>` The `redact` attribute only redacts the tag. Any inner text will be left behind if not enclosed in a `<redact>` tag. Redaction is permanent and can not be undone. Data is permanently deleted from Zendesk servers with no way to recover it. This endpoint provides all the same functionality that the [Redact String in Comment](/api-reference/ticketing/tickets/ticket_comments/#redact-string-in-comment) endpoint provides, plus: - Redaction of comments in closed tickets - Redaction of comments in archived tickets - Redaction of formatted text (bold, italics, hyperlinks) **Limitations**: - When content is redacted from an email comment, the content is also redacted from the original email through a background job. It may take a while for the changes to be completed. - Redaction is a synchronous process. For archived tickets, only one redaction request can be processed at a time per ticket. Concurrent redaction requests on the same archived ticket will receive a 409 Conflict response with a `Retry-After` header indicating how many seconds to wait before retrying (up to 30 seconds). The lock is released immediately when the redaction completes. This limit does not apply to requests from the Zendesk UI. **Note**: We recommend using this endpoint instead of the [Redact String in Comment](/api-reference/ticketing/tickets/ticket_comments/#redact-string-in-comment) endpoint, which will eventually be deprecated. #### Allowed For - Agents [Agent Workspace](https://support.zendesk.com/hc/en-us/articles/4408821259930) must be enabled on the account. For professional accounts, deleting tickets must be enabled for agents. On Enterprise accounts, you can assign agents to a custom role with permissions to redact ticket content. #### Rate limits When enabled, this endpoint has a rate limit shared by all agents and tickets in an account. The burst allowance holds up to 400 requests and replenishes at 9 requests per second, up to that capacity. Requests from the Zendesk UI are exempt from this endpoint-specific limit. Applicable account API limits also apply and can reduce throughput. Account API rate-limit headers do not report this endpoint-specific allowance. Requests that exceed this limit receive a 429 Too Many Requests response. Wait for the number of seconds specified in the returned `Retry-After` header before retrying. A retry can still be rate limited. #### Request Body Properties | Name | Type | Required | Description | | -------------------------| ------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------ | | ticket_id | integer | true | The ID of the ticket | | html_body | string | false | The `html_body` of the comment containing `<redact>` tags or `redact` attributes | | external_attachment_urls | array | false | Array of attachment URLs belonging to the comment to be redacted. See [`content_url` property of Attachment](/api-reference/ticketing/tickets/ticket-attachments/) |

    PUT /api/v2/comment_redactions/{ticket_comment_id}

  • Destructive

    Make Comment Private

    #### Allowed For * Agents

    PUT /api/v2/tickets/{ticket_id}/comments/{ticket_comment_id}/make_private

  • Destructive

    Redact String in Comment

    Permanently removes words or strings from a ticket comment. Specify the string to redact in an object with a `text` property. Example: `'{"text": "987-65-4320"}'`. The characters of the word or string are replaced by the ▇ symbol. If the comment was made by email, the endpoint also attempts to redact the string from the original email retained by Zendesk for audit purposes. **Note**: If you use the rich text editor, support for redacting formatted text (bold, italics, hyperlinks) is limited. Redaction is permanent. You can't undo the redaction or see *what* was removed. Once a ticket is closed, you can no longer redact strings from its comments. To use this endpoint, the "Agents can delete tickets" option must be enabled in the Zendesk Support admin interface at **Admin** > **Settings** > **Agents**. #### Allowed For * Agents

    PUT /api/v2/tickets/{ticket_id}/comments/{ticket_comment_id}/redact

Countries

  • Read

    List Countries and Calling Codes

    Returns a list of all countries with their calling codes. This endpoint is publicly accessible and does not require authentication. #### Allowed For * Anyone

    GET /api/v2/countries.json

  • Read

    Show Country

    Returns details for a specific country by ID. This endpoint is publicly accessible and does not require authentication. #### Allowed For * Anyone

    GET /api/v2/countries/{id}.json

Custom Objects

  • Read

    List Custom Objects

    Lists all undeleted custom objects for the account #### Allowed For * Agents

    GET /api/v2/custom_objects

  • Read

    Show Custom Object

    Returns an object with the specified key #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}

  • Read

    Custom Objects Limit

    List the current count and the limit for custom objects #### Allowed For * Admins

    GET /api/v2/custom_objects/limits/object_limit

  • Write

    Create Custom Object

    Creates an object describing all the properties required to create a custom object record #### Allowed For * Admins

    POST /api/v2/custom_objects

  • Write

    Update Custom Object

    Updates an individual custom object. The updating rules are as follows: * Takes a `custom_object` object that specifies the properties to update * The `key` property cannot be updated #### Allowed For * Admins

    PATCH /api/v2/custom_objects/{custom_object_key}

  • Destructive

    Delete Custom Object

    Permanently deletes the custom object with the specified key #### Allowed For * Admins

    DELETE /api/v2/custom_objects/{custom_object_key}

Custom Object Permissions

  • Read

    List Access Rules

    Returns a list of access rules for a custom object. Access rules define conditions that restrict which custom object records a role can access. #### Allowed For * Admins

    GET /api/v2/custom_objects/{custom_object_key}/access_rules

  • Read

    Show Access Rule

    Returns a specific access rule for a custom object. #### Allowed For * Admins

    GET /api/v2/custom_objects/{custom_object_key}/access_rules/{id}

  • Read

    List Access Rule Definitions

    Returns the available field definitions and operators that can be used when creating access rules for a custom object. This endpoint helps you understand what fields are available for filtering and what operators can be applied to each field type. #### Allowed For * Admins

    GET /api/v2/custom_objects/{custom_object_key}/access_rules/definitions

  • Read

    List Permission Policies

    Returns a list of permission policies for a custom object. Permission policies define what actions (create, read, update, delete) different roles can perform on custom object records. #### Allowed For * Admins

    GET /api/v2/custom_objects/{custom_object_key}/permission_policies

  • Read

    Show Permission Policy

    Returns a permission policy for a specific role on a custom object. The policy ID can be: - `custom-role-{custom_role_id}` for custom roles - `end-user` for the end user system role #### Allowed For * Admins

    GET /api/v2/custom_objects/{custom_object_key}/permission_policies/{id}

  • Write

    Create Access Rule

    Creates a new access rule for a custom object. Access rules define conditions that restrict which records a role can access based on field values or relationships. #### Allowed For * Admins

    POST /api/v2/custom_objects/{custom_object_key}/access_rules

  • Write

    Update Access Rule

    Updates an existing access rule for a custom object. #### Allowed For * Admins

    PATCH /api/v2/custom_objects/{custom_object_key}/access_rules/{id}

  • Write

    Update Permission Policy

    Updates a permission policy for a specific role on a custom object. Define what actions (create, read, update, delete) the role can perform and optionally specify access rules. #### Allowed For * Admins

    PATCH /api/v2/custom_objects/{custom_object_key}/permission_policies/{id}

  • Destructive

    Delete Access Rule

    Permanently deletes an access rule for a custom object. #### Allowed For * Admins

    DELETE /api/v2/custom_objects/{custom_object_key}/access_rules/{id}

Custom Object Fields

  • Read

    List Custom Object Fields

    Lists all undeleted custom fields for the specified object. #### Allowed For * Agents #### Pagination * Cursor pagination (recommended) * Offset pagination See [Pagination](/api-reference/introduction/pagination/).

    GET /api/v2/custom_objects/{custom_object_key}/fields

  • Read

    Show Custom Object Field

    Returns a custom field for a specific object using a provided key or id of the field. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/fields/{custom_object_field_key_or_id}

  • Read

    Custom Object Fields Limit

    List the current count and the limit for a custom object's fields #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/limits/field_limit

  • Write

    Create Custom Object Field

    Creates any of the following custom field types: * text (default when no "type" is specified) * textarea * checkbox * currency * date * integer * decimal * regexp * dropdown * lookup * multiselect * parent Additionally, you can create a roll-up summary field by specifying an existing type (`integer`, `decimal`, or `date`) with roll-up configuration in the `properties` object. See [About roll-up summary fields](/api-reference/custom-data/custom-objects/custom_object_fields/#about-roll-up-summary-fields). To make a text, integer, regexp, or lookup field require unique values, set `is_unique` to true in the `properties` object. See [About unique fields](/api-reference/custom-data/custom-objects/custom_object_fields/#about-unique-fields). See [About custom field types](https://support.zendesk.com/hc/en-us/articles/4408838961562) in Zendesk help. #### Allowed For * Admins

    POST /api/v2/custom_objects/{custom_object_key}/fields

  • Destructive

    Update Custom Object Field

    Updates individual custom object fields. The updating rules are as follows: * Takes a `custom_object_field` object that specifies the properties to update. * The `key` property cannot be updated. * If updating a standard field, only the `title`, `description`, and `properties` attributes can be updated. * Standard name field is always required. Therefore, the `required` property for standard name field isn't editable. * The `properties` parameter is comprised of four parts and can't be changed if any records exist for the object. * `autoincrement_enabled`: A Boolean that enables and disables autonumbering. Must be false if is_unique is true. * `autoincrement_prefix`: A string value that is used as a prefix to the autogenerated numbers. It can't exceed 30 characters. * `autoincrement_padding`: An integer specifying the starting number of digits in the autogenerated numbers. This value may be between 0-9. However, if you create records in excess of of these digits, additional digits are added as necessary. * `autoincrement_next_sequence`: An integer that will be used as the next number in the autonumbering sequence. It can't be negative or less than the current autonumbering value. * `is_unique`: A Boolean that enforces uniqueness for manually entered record names. When true, custom object record names must be unique. Must be false if autoincrement_enabled is true. * For text, integer, regexp, and lookup fields, `properties` can include `is_unique`, a Boolean that requires each record to have a different value in the field. Unlike the name field's properties, it can be changed when records exist: it can be turned on only if no record has a value for the field, and it can always be turned off. See [About unique fields](#about-unique-fields). #### Updating drop-down field options You can also use the update endpoint to add, update, or remove options in a drop-down custom field. Updating field options for multi-select fields works exactly the same as drop-down field options. **Important**: Unless you want to remove some options, you must specify all existing options in any update request. Omitting an option removes it from the drop-down field, which removes its values from any tickets or macros. Use the `custom_field_options` attribute to update the options. The attribute consists of an array of option objects, with each object consisting of an `id`, `name`, and `value` property. The name and value properties correspond to the "Title" and "Tag" text boxes in the admin interface respectively. For new drop-down options, specify `"id":"null"`. Example request body: ```json {"custom_object_field": { "custom_field_options": [ {"id": "null", "name": "Apple Pie", "value": "apple"}, {"id": "null", "name": "Pecan Pie", "value": "pecan"} ] } } ``` #### Example Request ```bash curl https://{subdomain}.zendesk.com/api/v2/custom_objects/{custom_object_key}/fields/{custom_object_field_key_or_id} -d '{"ticket_field": {"custom_field_options": [{"name": "Apple Pie", "value": "apple"}, {"name": "Pecan Pie", "value": "pecan"}]}}' \ -H "Content-Type: application/json" -X PUT \ -v -H "Authorization: Bearer {access_token}" ``` #### Allowed For * Admins

    PATCH /api/v2/custom_objects/{custom_object_key}/fields/{custom_object_field_key_or_id}

  • Destructive

    Delete Custom Object Field

    Deletes a field with the specified key. Note: You can't delete standard fields. #### Allowed For * Admins

    DELETE /api/v2/custom_objects/{custom_object_key}/fields/{custom_object_field_key_or_id}

  • Destructive

    Reorder Custom Fields of an Object

    Sets a preferred order of custom fields for a specific object by providing field ids in the desired order. #### Allowed For * Admins

    PUT /api/v2/custom_objects/{custom_object_key}/fields/reorder

Custom Object Records

  • Read

    List Custom Object Records

    Lists all undeleted custom object records for the specified object. If the object has a parent field with `cascade_permissions_enabled`, non-admin agents receive a `403 Forbidden` response. Use the [Filtered Search endpoint](#filtered-search-of-custom-object-records) with a filter on the parent field instead. #### Pagination * [Cursor pagination](/api-reference/introduction/pagination/#cursor-pagination) only. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records

  • Read

    Show Custom Object Record

    Returns a custom record for a specific object using a provided id. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records/{custom_object_record_id}

  • Read

    Autocomplete Custom Object Record Search

    Retrieves an array of custom object records that have a field value that matches the value specified in the `name` parameter. If the object has a parent field with `cascade_permissions_enabled`, the request must be made in the context of a cascade parent field using the `field_id` and `source` parameters. #### Pagination * [Cursor pagination](/api-reference/introduction/pagination/#cursor-pagination) only. * Returns the first 10,000 records sorted by relevancy with page limits. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records/autocomplete

  • Read

    Count Custom Object Records

    Returns a total count of records for a specific custom object as well as the time the count was refreshed. If the object has a parent field with `cascade_permissions_enabled`, non-admin agents receive a `403 Forbidden` response. Use the [Filtered Search endpoint](/api-reference/custom-data/custom-objects/custom_object_records/#filtered-search-of-custom-object-records) with a filter on the parent field instead. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records/count

  • Read

    Search Custom Object Records

    Returns an array of custom object records where the search query matches the values in Text Fields, Multi Line Text fields, and RegExp fields. To find records in other fields, use the [Filtered Search API](/api-reference/custom-data/custom-objects/custom_object_records/#filtered-search-of-custom-object-records) endpoint. If the object has a parent field with `cascade_permissions_enabled`, non-admin agents receive a `403 Forbidden` response. Use the [Filtered Search endpoint](/api-reference/custom-data/custom-objects/custom_object_records/#filtered-search-of-custom-object-records) with a filter on the parent field instead. #### Pagination * [Cursor pagination](/api-reference/introduction/pagination/#cursor-pagination) only. * Returns the records sorted by relevancy with page limits. Without a `sort` parameter, only the first 10,000 records are returned. With a `sort` parameter, all records are returned. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records/search

  • Read

    Show Custom Object Record by Unique Identifier

    Returns a custom object record identified by its external id, its name, or the value of one of the custom object's unique fields. Send exactly one identifier per request. * To identify the record by name, the `is_unique` property on the custom object's name field must be enabled. * To identify the record by a unique field, send the field's key as the query parameter, for example `?vin=1HGCM82633A004352`. The field's `is_unique` property must be enabled. For a unique lookup field, the value is the id of the record the field references. Returns a `400 Bad Request` if more than one identifier is sent, if `name` is sent and the name field isn't unique, or if no identifier is sent. A parameter that isn't the key of a unique field doesn't count as an identifier. Returns a `404 Not Found` if no record matches. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records/show_by_unique_identifier

  • Read

    Custom Object Records Limit

    List the current count and the limit for custom object records #### Allowed For * Agents

    GET /api/v2/custom_objects/limits/record_limit

  • Read

    Incremental Custom Object Record Export, Cursor Based

    Returns the custom object records that changed since the start time. This endpoint supports cursor-based incremental exports for custom object records. This endpoint only supports cursor-based pagination and does not support offset-based pagination. Cursor-based exports provide more consistent performance and response body sizes. For more information, see [Cursor-based incremental exports](/documentation/ticketing/managing-tickets/using-the-incremental-export-api#cursor-based-incremental-exports) in [Using the Incremental Exports API](/documentation/ticketing/managing-tickets/using-the-incremental-export-api). #### Allowed For * Admins * Agents with custom object read permissions #### Rate Limiting You can make up to 10 requests per minute to this endpoint. #### Notes - `start_time` is only required for the initial request for the pages in the record set, then `cursor` is required for all subsequent requests - The `start_time` must be more than 60 seconds ago - Deleted records will have their field values replaced with "[DELETED]" unless excluded via filter - Photo fields are excluded from incremental export responses

    GET /api/v2/incremental/custom_objects/{custom_object_key}/cursor

  • Write

    Custom Object Record Bulk Jobs

    Queues a background job to perform bulk actions on up to 100 custom object records per single request. Takes a `job` object with the following nested fields: * `action`, one of: * `"create"` * `"delete"` * `"delete_by_external_id"` * `"delete_by_unique_field"` * `"create_or_update_by_external_id"` * `"create_or_update_by_name"` * `"create_or_update_by_unique_field"` * `"update"` * `items` * For a `"create"` action, an array of JSON objects representing the custom object records being created * For a `"delete"` action, an array of strings representing Zendesk record ids * For a `"delete_by_external_id"` action, an array of strings representing external ids * For a `"delete_by_unique_field"` action, an array of strings representing values of the unique field named in `unique_field_key` * For a `"create_or_update_by_external_id"` action, an array of JSON objects representing the custom object records being created or updated by external id * For a `"create_or_update_by_name"` action, an array of JSON objects representing the custom object records being created or updated by name. The `is_unique` property on the custom object's name field must be enabled. * For a `"create_or_update_by_unique_field"` action, an array of JSON objects representing the custom object records being created or updated by the unique field named in `unique_field_key`. Each object must include that field's value in `custom_object_fields`. * For an `"update"` action, an array of JSON objects representing the custom object records being updated * `unique_field_key`, required for the `"create_or_update_by_unique_field"` and `"delete_by_unique_field"` actions: the key of the custom object field that identifies the records. The field's `is_unique` property must be enabled. Use the `*_by_name` actions to identify records by name. Note: If autonumbering is selected for the custom object's name field, record names aren't allowed in the request body because they are generated automatically. If uniqueness is enabled, the record names must be unique. #### Identifying records by a unique field Returns a `400 Bad Request` with the error `InvalidUniqueFieldKey` if `unique_field_key` is missing or isn't the key of a unique field on the custom object. In the job status `results`, each item of a `"delete_by_unique_field"` job reports the `unique_field_key` and `value` from the request, along with its `index` and `status` (for example, `"Deleted"`). An item that matches no record fails with "Record not found". Each item in a `"create_or_update_by_unique_field"` job reports the record's `id`, its `index` and `status`. An item without a value for the unique field fails with "Unique field value cannot be blank". If the field's uniqueness is turned off before the job runs, its items fail with "Uniqueness must be enabled on the field to identify records by it". #### Allowed For * Agents #### Response ### This endpoint returns a `job_status` [JSON object](/api-reference/ticketing/ticket-management/job_statuses/#json-format) and queues a background job to do the work. Use the [Show Job Status](/api-reference/ticketing/ticket-management/job_statuses/#show-job-status) endpoint to check for the job's completion. Only a certain number of jobs can be queued or running at the same time. See [Job limit](/api-reference/introduction/rate-limits/#job-limit) for more information.

    POST /api/v2/custom_objects/{custom_object_key}/jobs

  • Write

    Create Custom Object Record

    Creates a custom object record according to all the properties described by a custom object definition. If `autoincrement_enabled` is true, record names aren't allowed in the request body because they are generated automatically. If `is_unique` is true, record names must be unique. If the custom object has a parent relationship field, the parent field is required and must reference a valid parent record. Set the value in `custom_object_fields` using the parent record's id, external id (`"external_id:value"`), or name (`"name:value"`). #### Allowed For * Agents

    POST /api/v2/custom_objects/{custom_object_key}/records

  • Write

    Create or Update Custom Object Record

    Creates or updates a custom object record based on the provided external id, name, or unique field value. If a record exists for the given identifier, the endpoint updates it. Only the specified attributes are updated. Otherwise, the endpoint creates a new record with the provided identifier and other attributes. Specify only one identifier per request. * The `is_unique` property on the custom object's name field must be enabled in order to update or create by name. * To update or create by a unique field, send the field's key as the query parameter, for example `?vin=1HGCM82633A004352`. The field's `is_unique` property must be enabled. A new record is created with that value in the field. #### Allowed For * Agents

    PATCH /api/v2/custom_objects/{custom_object_key}/records

  • Write

    Update Custom Object Record

    Updates an individual custom object record. The updating rules are as follows: * Takes a `custom_object_record` object that specifies the properties to update * The custom object fields should be nested inside a `custom_object_fields` object #### Allowed For * Agents

    PATCH /api/v2/custom_objects/{custom_object_key}/records/{custom_object_record_id}

  • Write

    Filtered Search of Custom Object Records

    Returns an array of custom object records that meet the search and filter criteria. For simple searches limited to only text fields and no complex logic, use the [Search Custom Object Records API](/api-reference/custom-data/custom-objects/custom_object_records/#search-custom-object-records) endpoint. If the object has a parent field with `cascade_permissions_enabled`, non-admin agents must include a filter on the parent field (for example, `"custom_object_fields.parent_field_key": { "$eq": "parent_record_id" }`). Requests without a parent filter return `403 Forbidden`. Filters can contain either an individual [comparison object](#comparison-object) or an array of filter expressions within logical namespaces. Filter expressions can themselves be either comparison objects or `$and` / `$or` groups, so logical operators can be nested to build complex Boolean queries. A filter is a JSON object that has the following properties: | Name | Type | Required | Description | --------- | ------ | -------- | ----------- | ATTRIBUTE | object | no | A [comparison object](#comparison-object) specifying an attribute value condition to be met for records to match.<br/><br/>Examples are marked below. | $and | array | no | Array of filter expressions combined with logical AND. Each element may be a comparison object or a nested `$and` / `$or` group. | $or | array | no | Array of filter expressions combined with logical OR. Each element may be a comparison object or a nested `$and` / `$or` group. Limits for nested `$and` / `$or` groups: * Maximum nesting depth: `5` (outermost `$and` / `$or` counts as level 1). Exceeding it returns `422 Invalid Condition`. * Attribute keys cannot share a level with `$and` / `$or` once the payload contains any `$and` / `$or` nested inside another `$and` / `$or`. The request returns `422 Invalid Condition`; wrap the attribute inside the group instead. ##### Examples ```js { "filter": { "custom_object_fields.field_key": { "$eq": "value" } // ATTRIBUTE } } ``` ```js { "filter": { "$or": [ { "custom_object_fields.field_key": { "$eq": "value" } }, // ATTRIBUTE { "external_id": { "$eq": "Record123" } } // ATTRIBUTE ] } } ``` ```js // Nested $and / $or { "filter": { "$and": [ { "custom_object_fields.contract_term_months": { "$gt": 5 } }, { "$or": [ { "custom_object_fields.status": { "$eq": "active" } }, { "custom_object_fields.status": { "$eq": "pending" } } ] } ] } } ``` #### Comparison Object A comparison object defines a condition a record must meet to be considered a match. The condition is based on an attribute value or object type. A comparison object is a JSON object that has the following properties: | Name | Type | Required | Description | --------- | ------------- | -------- | ----------- | FIELD_KEY | string | yes | When filtering on a custom field, they must be namedspaced with `custom_object_fields.`. ex. `custom_object_fields.field_key`<br/><br/>When filtering on a standard field, no namespace is required. The following fields are considered standard: `created_at`, `updated_at`, `created_by_user`, `updated_by_user`, `name`, `external_id` | OPERATOR | string | yes | [Supported operators](/documentation/custom-data/v2/searching-custom-object-records/) vary by the value's data type | VALUE | string, array | yes | The value you're filtering for * Date values should be in [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601) format. #### Pagination * [Cursor pagination](/api-reference/introduction/pagination/#cursor-pagination) only. * Returns the records sorted by relevancy with page limits. Without a `sort` parameter, only the first 10,000 records are returned. With a `sort` parameter, all records are returned. #### Allowed For * Agents * End users (when an admin [configures](https://support.zendesk.com/hc/en-us/articles/6034260247066) the custom object to be accessible to end users)

    POST /api/v2/custom_objects/{custom_object_key}/records/search

  • Write

    Update Custom Object Record by Unique Identifier

    Updates a custom object record identified by its external id, its name, or the value of one of the custom object's unique fields. Unlike [Create or Update Custom Object Record](#create-or-update-custom-object-record), it never creates a record. Send exactly one identifier per request. * To identify the record by name, the `is_unique` property on the custom object's name field must be enabled. * To identify the record by a unique field, send the field's key as the query parameter, for example `?vin=1HGCM82633A004352`. The field's `is_unique` property must be enabled. For a unique lookup field, the value is the id of the record the field references. The update rules are the same as for [Update Custom Object Record](#update-custom-object-record): * Send a `custom_object_record` object that specifies the properties to update * Nest the custom object fields inside a `custom_object_fields` object Returns a `400 Bad Request` if more than one identifier is sent, if `name` is sent and the name field isn't unique, or if no identifier is sent. A parameter that isn't the key of a unique field doesn't count as an identifier. Returns a `404 Not Found` if no record matches. #### Allowed For * Agents

    PATCH /api/v2/custom_objects/{custom_object_key}/records/update_by_unique_identifier

  • Destructive

    Delete Custom Object Record by External Id Or Name

    Deletes a record with the specified external id, name, or unique field value. Specify only one identifier per request. * The `is_unique` property on the custom object's name field must be enabled in order to delete by name. * To delete by a unique field, send the field's key as the query parameter, for example `?vin=1HGCM82633A004352`. The field's `is_unique` property must be enabled. If the record is a parent in a parent-child relationship, all associated child records are also deleted asynchronously via a background job. #### Allowed For * Agents

    DELETE /api/v2/custom_objects/{custom_object_key}/records

  • Destructive

    Delete Custom Object Record

    Deletes a record with the specified id. If the record is a parent in a parent-child relationship, all associated child records are also deleted asynchronously via a background job. Child records are soft-deleted first and then permanently deleted after a 30-day retention period. The delete request returns immediately; the cascade deletion happens in the background. #### Allowed For * Agents

    DELETE /api/v2/custom_objects/{custom_object_key}/records/{custom_object_record_id}

  • Destructive

    Update Custom Object Record by Unique Identifier (PUT)

    Same as [Update Custom Object Record by Unique Identifier](#update-custom-object-record-by-unique-identifier), using PUT. #### Allowed For * Agents

    PUT /api/v2/custom_objects/{custom_object_key}/records/update_by_unique_identifier

Custom Object Record Attachments

  • Read

    List Custom Object Record Attachments

    Lists all attachments associated with a custom object record. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records/{record_id}/attachments

  • Read

    Download Custom Object Record Attachment

    Downloads the specified attachment content. Returns a redirect to the attachment's content URL. Access to malicious attachments is controlled by the `malware_access_override` setting. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/records/{record_id}/attachments/{id}/download

  • Write

    Create Custom Object Record Attachment

    Creates a new attachment associated with a custom object record. The custom object must have the "allows_attachments" setting enabled. #### Allowed For * Agents

    POST /api/v2/custom_objects/{custom_object_key}/records/{record_id}/attachments

  • Destructive

    Update Custom Object Record Attachment for Malware

    Updates malware access settings for the specified attachment. This is typically used to allow access to attachments that were flagged as containing malware. #### Allowed For * Admins

    PUT /api/v2/custom_objects/{custom_object_key}/records/{record_id}/attachments/{id}

  • Destructive

    Delete Custom Object Record Attachment

    Deletes the specified attachment associated with a custom object record. #### Allowed For * Agents

    DELETE /api/v2/custom_objects/{custom_object_key}/records/{record_id}/attachments/{id}

Object Triggers

  • Read

    List Object Triggers

    Lists all triggers for the specified custom object. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/triggers

  • Read

    Show Object Trigger

    Returns details of a specific object trigger. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/triggers/{trigger_id}

  • Read

    List Active Object Triggers

    Lists all active object triggers. #### Pagination - Cursor pagination (recommended) - Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Allowed For * Administrators * Agents in custom roles with the `manage_triggers` permission (Enterprise only)

    GET /api/v2/custom_objects/{custom_object_key}/triggers/active

  • Read

    List Object Trigger Action and Condition Definitions

    Lists the conditions and actions of all triggers for the specified custom object. #### Allowed For * Agents

    GET /api/v2/custom_objects/{custom_object_key}/triggers/definitions

  • Read

    Search Object Triggers

    Returns a list of object triggers that meet your filter or search criteria. #### Pagination * Offset pagination only See [Using Offset Pagination](/api-reference/introduction/pagination/#using-offset-pagination). #### Allowed For * Agents #### Filter Use the `filter` query parameter to filter an object trigger search by one or more attributes. For example, the following `filter` argument filters object triggers by the `title` attribute: ```json { "json": { "title": "test" } } ```

    GET /api/v2/custom_objects/{custom_object_key}/triggers/search

  • Write

    Create Object Trigger

    Creates a new object trigger for a specified object. #### Allowed For * Administrators * Agents in custom roles with the `manage_triggers` permission (Enterprise only)

    POST /api/v2/custom_objects/{custom_object_key}/triggers

  • Destructive

    Update Object Trigger

    Updates a specified object trigger. **Note**: Updating a condition or action updates both the conditions and actions arrays, clearing all existing values of both arrays. Include all your conditions and actions when updating any condition or action. #### Allowed For * Administrators * Agents in custom roles with the `manage_triggers` permission (Enterprise only)

    PUT /api/v2/custom_objects/{custom_object_key}/triggers/{trigger_id}

  • Destructive

    Delete Object Trigger

    Deletes a specified object trigger. #### Allowed For * Administrators * Agents in custom roles with the `manage_triggers` permission (Enterprise only)

    DELETE /api/v2/custom_objects/{custom_object_key}/triggers/{trigger_id}

  • Destructive

    Delete Many Object Triggers

    Deletes the object triggers corresponding to the provided comma-separated list of ids. **Note**: You can only bulk-delete triggers associated with one object at a time, specified by the `custom_object_key` in the request. #### Allowed For * Administrators * Agents in custom roles with the `manage_triggers` permission (Enterprise only) #### Request Parameters The DELETE request takes an `ids` object that lists the object triggers to delete. All of the specified object trigger `ids` must be associated with a single object. | Name | Description | ---- | ----------- | ids | The ids of the triggers to delete #### Example request ```js { "ids": "25,23,27,22" } ```

    DELETE /api/v2/custom_objects/{custom_object_key}/triggers/destroy_many

  • Destructive

    Update Many Object Triggers

    Updates the position or the active status of multiple object triggers. Any additional properties are ignored. **Note**: You can only bulk-update triggers associated with one object at a time, specified by the `custom_object_key` in the request. #### Allowed For * Administrators * Agents in custom roles with the `manage_triggers` permission (Enterprise only) #### Request Parameters The PUT request expects a `triggers` object that lists the object triggers to update. All of the specified object trigger `ids` must be associated with a single object. You can specify the following properties for each object trigger you're updating: | Name | Mandatory | Description | -------- | --------- | ----------- | id | yes | The ID of the object trigger to update | position | no | The new position of the object trigger | active | no | The active status of the object trigger (true or false) #### Example Request ```js { "triggers": [ {"id": 25, "position": 3}, {"id": 23, "active": true}, {"id": 27, "position": 9, "active": false}, {"id": 22, "position": 7} ] } ```

    PUT /api/v2/custom_objects/{custom_object_key}/triggers/update_many

Custom Roles

  • Read

    List Custom Roles

    #### Availability * Accounts on the Enterprise plan or above #### Allowed For * Agents

    GET /api/v2/custom_roles

  • Read

    Show Custom Role

    #### Availability * Accounts on the Enterprise plan or above #### Allowed for * Agents

    GET /api/v2/custom_roles/{custom_role_id}

  • Write

    Create Custom Role

    #### Availability * Accounts on the Enterprise plan or above #### Allowed for * Administrators * Agents with the `manage_roles` permission

    POST /api/v2/custom_roles

  • Destructive

    Update Custom Role

    #### Availability * Accounts on the Enterprise plan or above #### Allowed for * Administrators Agents with the `manage_roles` permission

    PUT /api/v2/custom_roles/{custom_role_id}

  • Destructive

    Delete Custom Role

    #### Availability * Accounts on the Enterprise plan or above #### Allowed for * Administrators * Agents with the `manage_roles` permission

    DELETE /api/v2/custom_roles/{custom_role_id}

Custom Ticket Statuses

  • Read

    List Custom Ticket Statuses

    Lists all undeleted custom ticket statuses for the account. No pagination is provided. #### Allowed For * End Users

    GET /api/v2/custom_statuses

  • Read

    Show Custom Ticket Status

    Returns the custom ticket status object. #### Allowed For * End Users

    GET /api/v2/custom_statuses/{custom_status_id}

  • Read

    Show Many Custom Ticket Statuses

    Returns the undeleted custom ticket statuses specified by a comma-separated list of ids. Up to 100 ids are accepted. If `ids` is not provided, all undeleted custom ticket statuses for the account are returned. The response payload matches the [List Custom Ticket Statuses](#list-custom-ticket-statuses) response format. #### Allowed For * End Users

    GET /api/v2/custom_statuses/show_many

  • Write

    Create Custom Ticket Status

    Takes a `custom_status` object that specifies the custom ticket status properties to create. #### Allowed For * Admins

    POST /api/v2/custom_statuses

  • Write

    Create Ticket Form Statuses for a Custom Status

    Creates one or many tickets form status associations for a custom status. #### Allowed For * Admins

    POST /api/v2/custom_statuses/{custom_status_id}/ticket_form_statuses

  • Destructive

    Bulk Update Default Custom Ticket Status

    Updates the default values for many custom ticket statuses at once. #### Allowed For * Admins

    PUT /api/v2/custom_status/default

  • Destructive

    Update Custom Ticket Status

    Takes a `custom_status` object that specifies the properties to update. #### Allowed For * Admins

    PUT /api/v2/custom_statuses/{custom_status_id}

  • Destructive

    Delete Custom Ticket Status

    Deletes the custom ticket status. The status must first be unassigned from all active (non-closed) tickets before it can be deleted. #### Allowed For * Admins

    DELETE /api/v2/custom_statuses/{custom_status_id}

Tickets

  • Read

    List Deleted Tickets

    Returns a maximum of 100 deleted tickets per page. See [Pagination](/api-reference/introduction/pagination/). The results includes all deleted (and not yet archived) tickets that have not yet been [scrubbed](https://support.zendesk.com/hc/en-us/articles/4408845703194#topic_fv5_w51_sdb) in the past 30 days. Archived tickets are not included in the results. See [About archived tickets](https://support.zendesk.com/hc/en-us/articles/4408887617050) in the Support Help Center. The tickets are ordered chronologically by created date, from oldest to newest. The first ticket listed may not be the oldest ticket in your account due to [ticket archiving](https://support.zendesk.com/hc/en-us/articles/4408887617050). #### Pagination - Cursor pagination (recommended) - Offset pagination See [Pagination](/api-reference/introduction/pagination/). Returns a maximum of 100 records per page. #### Allowed For * Agents #### Rate Limit You can make 10 requests every 1 minute using this endpoint. When making requests beyond page 100, you can make 5 requests every 1 minute. These rate limits apply to both API calls and actions performed in the Admin Center. The rate limiting mechanism behaves as described in [Monitoring your request activity](/api-reference/ticketing/account-configuration/usage_limits/#monitoring-your-request-activity) in the API introduction.

[...]
